{View 1.1 (C) Pavel Holecek - 7software     }
{Toto je freeware.                          }
{http://7software.wz.cz/                    }

{Sipky, PgUp, PgDown, Home, End  ->  Pohyb  }
{Insert  -> Vlozi/Zrusi zalozku             }
{"+", "-"  -> Vlozi/Zrusi vsechny zalozky   }
{F1 -> Napoveda                             }
{F2 -> Informace o souboru                  }
{F5 -> Prejde na dalsi zalozku              }
{F10 -> Menu                                }
{Esc -> Konec                               }
{Muzete pouzivat i mys.}

{Maximalni velikost zobrazeneho souboru je  }
{limitovana velikosti volne konvencni pameti}

uses crt,dos,myska;
const bgcolor=1;frcolor=14;
     K_LEFT         = #75;        K_RIGHT        = #77;
     K_UP           = #72;        K_DOWN         = #80;
     K_HOME         = #71;        K_END          = #79;
     K_PGUP         = #73;        K_PGDOWN       = #81;
     K_INSERT       = #82;        K_F5           = #63;
     K_F1           = #59;        K_F2           = #60;
     K_F10          = #68;

type pradka=^tradka;
     tradka=record
             next,prev:pradka;cislo:word;marked:boolean;
             text:string[79];
            end;
var ch:char;soubor:string;f:file;v,p,m:pradka;i:integer;akr,maxr:integer;a:pradka;
    buff:array[1..79] of char;numread:integer;abcode:boolean;
    t1,t2,t3:boolean;mx,my:word;kolik,kde,mr:integer;
    savescr:array[1..80,1..25] of word;

{*} infSize:longint;infAttr:word;infTime:datetime;nacterror:boolean;

function charx(ch:char;poc:integer):string;
var  i:integer;s:string;
begin
 s:='';for i:=1 to poc do s:=s+ch;charx:=s;
end;
function inttostr(i:longint):string;
var s:string;
begin
 str(i,s);
 inttostr:=s;
end;
procedure cursor(state:boolean);
var reg:registers;
const sstart:byte=12;send:byte=14;
begin
 case state of
  true: begin reg.AH:=1;reg.CH:=SStart;reg.CL:=SEnd end;
  false:begin reg.AH:=1;reg.CH:=32;    reg.CL:=0    end;
 end;
 intr($10,reg);
end;


procedure xwritexy(x,y:byte;s:string);
var i:integer;
begin
 x:=x-1;y:=y-1;
 for i:=0 to length(s)-1 do
 begin
  mem[SegB800:2*(x+(y*80)+i)]  :=byte(s[i+1]);
  mem[SegB800:2*(x+(y*80)+i)+1]:=textattr;
 end;
end;
procedure writexy(x,y:integer;s:string);
begin
 gotoxy(x,y);write(s);
end;
procedure writexyc(x,y:integer;s:string;c:byte);
begin
 textcolor(c);gotoxy(x,y);write(s);
end;

procedure zobraz(p:pradka;l:integer);
var i:integer;
begin
 if p=nil then exit;schovej_mysku;
 for i:=0 to l do if (p<>nil) and (p^.cislo<=maxr) then
 begin
  if p^.marked then begin textbackground(4);textcolor(15);end;
  xwritexy(1,i+1,p^.text+charx(' ',79-length(p^.text)));
  if p^.marked then begin textbackground(bgcolor);textcolor(frcolor);end;
  if p^.next=nil then break else p:=p^.next;
 end else xwritexy(1,i+1,charx(' ',79));
 ukaz_mysku;
end;
procedure zobrazproc;
var i:integer;
begin
 textbackground(7);
 mr:=maxr;if mr>24 then mr:=mr-24;
 kolik:=22;
 kolik:=round(kolik*(24 / mr));
 if kolik>22 then kolik:=22;

 kde:=22-kolik;
 kde:=round(kde*(akr / mr));
 if kde>22 then kde:=22;
 for i:=1 to 22 do
     if (i>=kde) and (i<=kde+kolik) then writexyc(80,i+1,#219,8) else writexyc(80,i+1,#176,8);
 kolik:=kde+kolik;
 textbackground(1);
 if (akr>0) and (a^.prev<>nil) then textcolor(14) else textcolor(7);
 xwritexy(80,1,#30);
 if (akr+22<maxr) and (a^.next<>nil) then textcolor(14) else textcolor(7);
 xwritexy(80,24,#31);
 textcolor(14);
end;
procedure zobrazstatus;
begin
 textbackground(3);schovej_mysku;
 writexy(8,25,charx(' ',15));
 writexyc(1,25,'Radek: '+inttostr(akr)+'/'+inttostr(maxr),1);
 textcolor(0);
 xwritexy(23,25,'Pouzi:'+#24+#25+', PgUp, PgDown, Home, End, Ins, +, -, F1,F2,F5,F10');
 zobrazproc;
 textcolor(frcolor);textbackground(bgcolor);
 ukaz_mysku;
end;

function getp(p:pradka;smer:integer):pradka;
var i:integer;a:pradka;
begin
 getp:=p;
 if smer>0 then
 for i:=1 to smer do if p^.next<>nil then p:=p^.next else begin p:=nil;break;end;
 if smer<0 then
 for i:=-1 downto smer do if p^.prev<>nil then p:=p^.prev else begin p:=nil;break;end;
 getp:=p;
end;

type tmenu=record
            x,y,x1,mx:byte;
            name:string[20];
            icount:byte;
            items:array[1..20] of string[30];
           end;

var menu:array[1..3] of tmenu;menuc,ma,mi:integer;
procedure initmenu;
begin
 menu[1].x:=60;menu[1].y:=1;menu[1].x1:=17;menu[1].mx:=63;
 menu[1].name:=' Soubor ';menu[1].icount:=4;
 menu[1].items[1]:='Statistika';menu[1].items[2]:='O programu';
 menu[1].items[3]:='-';menu[1].items[4]:='Konec';

 menu[2].x:=56;menu[2].y:=1;menu[2].x1:=21;menu[2].mx:=71;
 menu[2].name:=' Zalozky';menu[2].icount:=5;
 menu[2].items[1]:='Nastav/Zrus';menu[2].items[2]:='Nastav vsechny';
 menu[2].items[3]:='Zrus vsechny';menu[2].items[4]:='-';
 menu[2].items[5]:='Jdi na dalsi zalozku';

 ma:=1;mi:=1;menuc:=2;
end;
procedure drawmenub(m:integer);
begin
 with menu[m] do
 begin
  textcolor(0);textbackground(3);
  writexy(x,y+1,#218);
  writexy(x+x1+2,y+1,#191);
  writexy(x,y+2+icount,#192);
  writexy(x+x1+2,y+2+icount,#217);
  for i:=x+1 to x+x1+1 do
  begin
   writexy(i,y+1,#196);
   writexy(i,y+2+icount,#196);
  end;
  for i:=y+2 to y+1+icount do
  begin
   writexy(x,i,#179);
   writexy(x+x1+2,i,#179);
  end;
 end;
end;
procedure drawmenu(m:integer);
begin
 with menu[m] do
 begin
  for i:=1 to icount do
  begin
   if i=mi then begin textcolor(15);textbackground(0) end
     else begin textcolor(0);textbackground(3);end;
   if items[i]='-' then begin writexyc(x+1,y+i+1,charx(#196,x1+1),8);textcolor(0); end else
   writexy(x+1,y+i+1,' '+items[i]+charx(' ',x1-length(items[i])));
  end;
 end;
end;
procedure drawmbar;
begin
 textcolor(0);textbackground(3);
 writexy(1,1,charx(' ',78));writexyc(2,1,'View v1.1',4);writexyc(12,1,'-',0);writexyc(14,1,paramstr(1),1);
 for i:=1 to menuc do
 begin
  if i=ma then begin textcolor(15);textbackground(0) end
     else begin textcolor(0);textbackground(3);end;
  xwritexy(menu[i].mx,1,menu[i].name+' ');
 end;
end;
procedure zalozka;
begin
 if (a<>nil) then
  begin
   a^.marked:=not a^.marked;
   zobraz(a,23);
  end;
end;
procedure zalozkavse;
begin
 if (v<>nil) then
 begin
  p:=v;
  while p<>nil do begin p^.marked:=true;p:=p^.next;end;
  zobraz(a,23);
 end;
end;
procedure zalozkanic;
begin
 if (v<>nil) then
 begin
  p:=v;
  while p<>nil do begin p^.marked:=false;p:=p^.next;end;
  zobraz(a,23);
 end;
end;
procedure dalsizalozka;
begin
 if (akr+22<maxr) and (a^.next<>nil) then
  begin
    p:=a^.next;i:=akr+1;
    while p<>nil do if p^.marked=false then begin p:=p^.next;i:=i+1;end else
    begin
     akr:=i;
     a:=p;
     zobraz(a,23);zobrazstatus;
     break;
    end;
  end;
end;
procedure help;
begin
 move(ptr(SegB800,0)^,savescr,4000);schovej_mysku;
 textcolor(15);textbackground(7);
 for i:=0 to 23 do
  xwritexy(1,i+1,charx(' ',80));
 writexyc(30,2,'V I E W  verze 1.0',1);
 writexyc(25,3,'(C) Pavel Holecek - 7software',4);

 writexyc(1,5,'Tento program je freeware a muzete jej volne sirit.',0);
 writexyc(1,7,'Ovladani:',1);
 writexyc(3,8,#24+', '+#25+', PageUp,PageDown, Home, End',14);writexyc(40,8,'Pohyb v textu',1);
 writexyc(3,9,'Insert',14);writexyc(40,9,'Vlozi / zrusi zalozku',1);
 writexyc(3,10,'+',14);writexyc(40,10,'Nastavi vsechny radky, jako zalozky',1);
 writexyc(3,11,'-',14);writexyc(40,11,'Zrusi vsechny zalozky',1);
 writexyc(3,12,'F1',14);writexyc(40,12,'Zobrazi tuto napovedu',1);
 writexyc(3,13,'F5',14);writexyc(40,13,'Skok na dalsi zalozku',1);
 writexyc(3,14,'F10',14);writexyc(40,14,'Menu',1);
 writexyc(3,15,'Esc',14);writexyc(40,15,'Konec',1);
 writexyc(1,16,'Muzete pouzivat take mys (posuvnik v prave casti obrazovky).',0);
 writexyc(1,18,'Kontakt:',1);
 writexyc(3,19,'Pavel Holecek - 7 software',4);
 writexyc(3,20,'7software@seznam.cz',4);
 writexyc(3,21,'http://7software.wz.cz/',4);

 writexyc(10,24,'K pokracovani v prohlizeni textu zmacknete libovolnou klavesu...',0);
 ukaz_mysku;
 readkey;
 textbackground(1);textcolor(14);schovej_mysku;
 move(savescr,ptr(SegB800,0)^,4000);
 ukaz_mysku;
end;



function LeadingZero(w : Word) : String;
var
  s : String;
begin
  Str(w:0,s);
  if Length(s) = 1 then
    s := '0' + s;
  LeadingZero := s;
end;
procedure statistika;
var c:byte;
begin
 schovej_mysku;move(ptr(SegB800,0)^,savescr,4000);
 textcolor(15);textbackground(7);
 for i:=0 to 23 do
  xwritexy(1,i+1,charx(' ',80));
 writexyc(30,2,'I N F O R M A C E',1);
 writexyc(35,3,'o souboru',4);

 writexyc(1,5,'Jmeno souboru: ',1);writexyc(20,5,soubor,5);
 writexyc(1,6,'Cele jmeno: ',1);   writexyc(20,6,fexpand(soubor),5);

 writexyc(1,8,'Velikost souboru: ',1);writexyc(20,8,inttostr(infSize)+'b ('+inttostr(infSize div 1024)+'Kb)',5);
 writexyc(1,9,'Pocet radku: ',1);  writexyc(20,9,inttostr(maxr),5);
 if nacterror then writexyc(1,10,'!!! Pozor: soubor se nepodarilo nacist cely !!!',4);

 writexyc(1,11,'Soubor vytvoren: ',1);
 with infTime do writexyc(20,11,'Dne '+LeadingZero(day)+'.'+LeadingZero(month)+'.'+inttostr(year)
                          +' v '+LeadingZero(hour)+':'+LeadingZero(min)+':'+LeadingZero(sec),5);
 writexyc(1,12,'Atributy: ',1);
 if infAttr and Archive <> 0 then c:=14 else c:=8;writexyc(20,12,'Archivni ',c);
 if infAttr and ReadOnly <> 0 then c:=14 else c:=8;writexyc(20,13,'Pouze pro cteni',c);
 if infAttr and Hidden <> 0 then c:=14 else c:=8;writexyc(20,14,'Skryty',c);
 if infAttr and SysFile <> 0 then c:=14 else c:=8;writexyc(20,15,'Systemovy',c);
 writexyc(1,17,'Volna pamet: ',1);writexyc(20,17,inttostr(memavail)+'b ('+inttostr(memavail div 1024)+'Kb)',5);
 writexyc(10,24,'K pokracovani v prohlizeni textu zmacknete libovolnou klavesu...',0);
 ukaz_mysku;
 readkey;
 textbackground(1);textcolor(14);schovej_mysku;
 move(savescr,ptr(SegB800,0)^,4000);
 ukaz_mysku;
end;
procedure runmenu;
var s:string;c:byte;konec:boolean;
begin
 move(ptr(SegB800,0)^,savescr,4000);
 drawmbar;
 drawmenub(ma);mi:=1;konec:=false;
 drawmenu(ma);
 repeat
  ch:=#255;
  if keypressed then ch:=readkey;
  if ch=#27 then konec:=true;
  if ch=#13 then konec:=true;
  if ch=#0 then
  begin
   ch:=readkey;
   if ch=k_down then
   begin
    if mi<menu[ma].icount then mi:=mi+1 else mi:=1;
    if menu[ma].items[mi]='-' then mi:=mi+1;
    drawmenu(ma);
   end;
   if ch=k_up then
   begin
    if mi>1 then mi:=mi-1 else mi:=menu[ma].icount;
    if menu[ma].items[mi]='-' then mi:=mi-1;
    drawmenu(ma);
   end;
   if ch=k_left then
   begin
    if ma>1 then ma:=ma-1 else ma:=menuc;mi:=1;
    move(savescr,ptr(SegB800,0)^,4000);
    drawmbar;drawmenub(ma);drawmenu(ma);
   end;
   if ch=k_right then
   begin
    if ma<menuc then ma:=ma+1 else ma:=1;mi:=1;
    move(savescr,ptr(SegB800,0)^,4000);
    drawmbar;drawmenub(ma);drawmenu(ma);
   end;
  end;
 until konec;
 textbackground(1);textcolor(14);
 move(savescr,ptr(SegB800,0)^,4000);
 konec:=false;
 if ch=#13 then
 begin
  ch:=#255;
   if ma=2 then
   case mi of
    1:zalozka;
    2:zalozkavse;
    3:zalozkanic;
    5:dalsizalozka;
   end else
   if ma=1 then
   case mi of
    1:statistika;
    2:help;
    4:ch:=#27;
   end
 end else ch:=#255;
end;

begin
 writeln('Prohlizec souboru VIEW v 1.1   (C) Pavel Holecek - 7software');
 if paramcount<1 then
 begin
  textcolor(4);writeln('Chybi jmeno souboru'+#13+#10);textcolor(7);
  writeln('Pouzij: VIEW JmenoSouboru');halt(1);
 end;
 soubor:=paramstr(1);
 {$I-}assign(f,soubor);
      getfattr(f,infAttr);getftime(f,infSize);UnpackTime(infSize,infTime);
      reset(f,1);{$I+}
 if IOResult<>0 then
 begin
   textcolor(4);
   writeln('Soubor nenalezen, nebo nastala chyba pri jeho otevirani !');textcolor(7);
   halt;
 end;
 if filesize(f)=0 then
 begin
   textcolor(4);
   writeln('Neni co zobrazit. Soubor je prazdny !');textcolor(7);
   close(f);halt;
 end;
 infSize:=filesize(f);
 new(v);v^.prev:=nil;v^.text:='Prohlizim : '+soubor;v^.cislo:=1;v^.marked:=false;
 p:=v;maxr:=0;init_mysky(1);
 repeat
  {$I-}blockread(f,buff,79,numread);{$I+}
  if IOResult<>0 then
  begin
   textcolor(4);
   writeln('Pri nacitani souboru nastala chyba !!!');
   writeln('Bude zobrazeno pouze prvnich '+inttostr(maxr)+' radku !!!'+#7);
   nacterror:=true;
   delay(1000);numread:=0;
  end;
  if memavail<1024 then
  begin
   textcolor(4);
   writeln('Soubor se nevleze cely do pamety !!!');
   writeln('Bude zobrazeno pouze prvnich '+inttostr(maxr)+' radku !!!'+#7);
   nacterror:=true;
   delay(1000);numread:=0;
  end;
  new(p^.next);
  p^.next^.marked:=false;
  p^.next^.cislo:=p^.cislo+1;
  p^.next^.prev:=p;
  p^.next^.next:=nil;
  p^.text:='';
  for i:=1 to numread do if buff[i]<>#13 then p^.text:=p^.text+buff[i] else
  begin
   seek(f,filepos(f)-(numread-i-1));
   break;
  end;
  p:=p^.next;maxr:=maxr+1;
 until (numread = 0);
 close(f);
 akr:=1;m:=p^.prev;maxr:=maxr-1;

 a:=v;akr:=1;
 clrscr;cursor(false);textcolor(frcolor);textbackground(bgcolor);clrscr;
 zobraz(a,23);zobrazstatus;
 mem[SegB800:3999]:=48;textcolor(7);
 xwritexy(80,1,#30);textcolor(14);
 xwritexy(80,24,#31);
 initmenu;
 ukaz_mysku;

 repeat
  ch:=#255;
  pozice_mysky(mx,my,t1,t2,t3);
  mx:=mx div 8+1;my:=my div 8+1;
  if t1 then
  begin
   if mx=80 then
    if my=1      then begin abcode:=true;ch:=k_up;end else
    if my=24     then begin abcode:=true;ch:=k_down;end else
    if my<=kde   then begin abcode:=true;ch:=k_pgup;end else
    if my>=kolik then begin abcode:=true;ch:=k_pgdown;end else
  end;

  if keypressed and not abcode then ch:=readkey;
  if (ch=#0) or abcode then
  begin
   if not abcode then ch:=readkey else abcode:=false;
   if ch=k_down then if (akr+22<maxr) and (a^.next<>nil) then
   begin
    akr:=akr+1;a:=a^.next;
    zobraz(a,23);
    zobrazstatus;
   end;
   if ch=k_up then if (akr>0) and (a^.prev<>nil) then
   begin
    akr:=akr-1;a:=a^.prev;
    zobraz(a,23);
    zobrazstatus;
   end;
  if ch=k_pgup then if (akr>0) and (a^.next<>nil) then
  begin
   if akr<=23 then begin akr:=1;a:=v;end else
                   begin akr:=akr-24;a:=getp(a,-24);end;
   zobraz(a,23);
   zobrazstatus;
  end;
  if ch=k_pgdown then if (akr+22<maxr) and (a^.next<>nil) then
  begin
   if akr+44>=maxr then begin akr:=maxr-22;a:=getp(m,-22);end else
                   begin akr:=akr+24;a:=getp(a,24);end;
   zobraz(a,23);
   zobrazstatus;
  end;
  if ch=k_home then if (akr>0) and (v<>nil) then
  begin
   akr:=1;a:=v;
   zobraz(a,23);
   zobrazstatus;
  end;
  if ch=k_end then if (akr>0) and (v<>nil) then
  begin
   akr:=maxr-22;a:=getp(m,-22);
   zobraz(a,23);
   zobrazstatus;
  end;
  if ch=k_insert then zalozka;
  if ch=k_F1 then help;
  if ch=k_F2 then statistika;
  if ch=k_F5 then dalsizalozka;
  if ch=k_F10 then runmenu;
 end;
 if ch='+' then zalozkavse;
 if ch='-' then zalozkanic;
 until ch=#27;

 p:=v;cursor(true);textcolor(7);textbackground(0);clrscr;
 while p^.next<>nil do begin
   p:=p^.next;dispose(p^.prev);
 end;
end.